library attribute_directives.shorten_overflow_text;

import 'dart:html' as html;
import 'dart:math';
import 'package:angular2/angular2.dart';

@Directive(selector: '[foShortenOverflow]')
class ShortenOverflowTextDirective implements OnChanges
{
  ShortenOverflowTextDirective(ElementRef element_ref)
      : _element = element_ref.nativeElement, _parentElement = element_ref.nativeElement.parent
  {
    html.window.onResize.listen((_) => _adjustTextLength());
  }

  void ngOnChanges(Map<String, dynamic> data)
  {
    _adjustTextLength();
    print("ONCHANGES");
    print(_fullText);
  }

  /*
  void ngAfterContentChecked()
  {
    _adjustTextLength();
  }
  */

  void _adjustTextLength()
  {
    if (_fullText == null) return;

    String croppedValue = _fullText;

    html.Rectangle<double> parentRect = _parentElement.getBoundingClientRect();
    html.Rectangle<double> rect = _element.getBoundingClientRect();
    double parentWidth = parentRect.right - parentRect.left;
    double width = rect.right - rect.left;
    double dotMargin = 20.0;
    int overflowGuard = 999;

    while (width + dotMargin > parentWidth && overflowGuard > 0)
    {
      croppedValue = croppedValue.substring(0, max(croppedValue.length - 1, 0));
      _element.text = croppedValue;
      rect = _element.getBoundingClientRect();
      width = rect.right - rect.left;
      overflowGuard--;
    }
    print(croppedValue);

    _element.text = (overflowGuard < 999) ? croppedValue + "..." : croppedValue;
  }

  @Input('foShortenOverflow')
  void set text(String value)
  {
    _fullText = value;
    _adjustTextLength();
  }

  final html.Element _element;
  final html.Element _parentElement;
  String _fullText;
}